#!/bin/sh
#$ -S /bin/sh
#$ -N stacks_construction_071014
#$ -cwd
#$ -j y
#$ -pe mpi-fillup 12

# complete rerun of stacks 07/10/14 - excluding low hz individuals
# nb: these are still included in ustacks stage but are excluded from catalogue construction

# set up directory and path

export PATH=$HOME/local/bin:$PATH
cd $HOME/data/littorina

###### PART 1: STANDARD CATALOGUE CONSTRUCTION ######

### STEP 1: USTACKS ###

echo "|| STANDARD USTACKS ||"

i=1

for FILE in ./raw/*.fq.gz
do
	# run the ustacks pipeline

	ustacks -t gzfastq -f $FILE -o $HOME/data/littorina/standard_catalogue_071014 -d -r -i $i -m 5 \
	-M 8 -p 12 --max_locus_stacks 2 -H -N 0 --model_type snp --alpha 0.01
	
	# after each run, alter the value of $i
	
	let i=$i+1
	
done

### STEP 2: CSTACKS ###

echo "|| STANDARD CSTACKS ||"

cstacks -b 1 -o ./standard_catalogue_071014/ -n 8 -p 12 \
-s ./standard_catalogue_071014/EJ02 \
-s ./standard_catalogue_071014/EJ03 \
-s ./standard_catalogue_071014/EJ04 \
-s ./standard_catalogue_071014/EJ05 \
-s ./standard_catalogue_071014/EJ06 \
-s ./standard_catalogue_071014/EJ07 \
-s ./standard_catalogue_071014/EJ08 \
-s ./standard_catalogue_071014/EJ09 \
-s ./standard_catalogue_071014/EJ10 \
-s ./standard_catalogue_071014/EJ11 \
-s ./standard_catalogue_071014/EJ12 \
-s ./standard_catalogue_071014/EJ13 \
-s ./standard_catalogue_071014/EJ15 \
-s ./standard_catalogue_071014/EJ16 \
-s ./standard_catalogue_071014/EJ18 \
-s ./standard_catalogue_071014/EJ19 \
-s ./standard_catalogue_071014/EJ20 \
-s ./standard_catalogue_071014/EJ21 \
-s ./standard_catalogue_071014/EJ22 \
-s ./standard_catalogue_071014/EJ23 \
-s ./standard_catalogue_071014/EJ24 \
-s ./standard_catalogue_071014/EJ25 \
-s ./standard_catalogue_071014/EJ27 \
-s ./standard_catalogue_071014/EJ28 \
-s ./standard_catalogue_071014/ER01 \
-s ./standard_catalogue_071014/ER02 \
-s ./standard_catalogue_071014/ER03 \
-s ./standard_catalogue_071014/ER04 \
-s ./standard_catalogue_071014/ER05 \
-s ./standard_catalogue_071014/ER06 \
-s ./standard_catalogue_071014/ER07 \
-s ./standard_catalogue_071014/ER08 \
-s ./standard_catalogue_071014/ER09 \
-s ./standard_catalogue_071014/ER11 \
-s ./standard_catalogue_071014/ER12 \
-s ./standard_catalogue_071014/ER13 \
-s ./standard_catalogue_071014/ER14 \
-s ./standard_catalogue_071014/ER15 \
-s ./standard_catalogue_071014/ER16 \
-s ./standard_catalogue_071014/ER17 \
-s ./standard_catalogue_071014/ER18 \
-s ./standard_catalogue_071014/ER20 \
-s ./standard_catalogue_071014/ER21 \
-s ./standard_catalogue_071014/ER22 \
-s ./standard_catalogue_071014/ER23 \
-s ./standard_catalogue_071014/ER24 \
-s ./standard_catalogue_071014/ES09 \
-s ./standard_catalogue_071014/ES13 \
-s ./standard_catalogue_071014/ES15 \
-s ./standard_catalogue_071014/ES16 \
-s ./standard_catalogue_071014/ES17 \
-s ./standard_catalogue_071014/ES18 \
-s ./standard_catalogue_071014/ES19 \
-s ./standard_catalogue_071014/ES20 \
-s ./standard_catalogue_071014/ES21 \
-s ./standard_catalogue_071014/ES22 \
-s ./standard_catalogue_071014/ES23 \
-s ./standard_catalogue_071014/ES24 \
-s ./standard_catalogue_071014/ES25 \
-s ./standard_catalogue_071014/ES26 \
-s ./standard_catalogue_071014/ES27 \
-s ./standard_catalogue_071014/ES28 \
-s ./standard_catalogue_071014/SJ01 \
-s ./standard_catalogue_071014/SJ02 \
-s ./standard_catalogue_071014/SJ03 \
-s ./standard_catalogue_071014/SJ04 \
-s ./standard_catalogue_071014/SJ05 \
-s ./standard_catalogue_071014/SJ06 \
-s ./standard_catalogue_071014/SJ07 \
-s ./standard_catalogue_071014/SJ08 \
-s ./standard_catalogue_071014/SJ09 \
-s ./standard_catalogue_071014/SJ10 \
-s ./standard_catalogue_071014/SJ11 \
-s ./standard_catalogue_071014/SJ12 \
-s ./standard_catalogue_071014/SJ13 \
-s ./standard_catalogue_071014/SJ14 \
-s ./standard_catalogue_071014/SJ15 \
-s ./standard_catalogue_071014/SJ16 \
-s ./standard_catalogue_071014/SJ17 \
-s ./standard_catalogue_071014/SJ18 \
-s ./standard_catalogue_071014/SJ20 \
-s ./standard_catalogue_071014/SJ21 \
-s ./standard_catalogue_071014/SJ22 \
-s ./standard_catalogue_071014/SJ23 \
-s ./standard_catalogue_071014/SJ24 \
-s ./standard_catalogue_071014/SJ25 \
-s ./standard_catalogue_071014/SR01 \
-s ./standard_catalogue_071014/SR02 \
-s ./standard_catalogue_071014/SR03 \
-s ./standard_catalogue_071014/SR04 \
-s ./standard_catalogue_071014/SR05 \
-s ./standard_catalogue_071014/SR06 \
-s ./standard_catalogue_071014/SR07 \
-s ./standard_catalogue_071014/SR08 \
-s ./standard_catalogue_071014/SR09 \
-s ./standard_catalogue_071014/SR10 \
-s ./standard_catalogue_071014/SR11 \
-s ./standard_catalogue_071014/SR12 \
-s ./standard_catalogue_071014/SR13 \
-s ./standard_catalogue_071014/SR14 \
-s ./standard_catalogue_071014/SR15 \
-s ./standard_catalogue_071014/SR16 \
-s ./standard_catalogue_071014/SR18 \
-s ./standard_catalogue_071014/SR21 \
-s ./standard_catalogue_071014/SR22 \
-s ./standard_catalogue_071014/SR23 \
-s ./standard_catalogue_071014/SR25 \
-s ./standard_catalogue_071014/SS05 \
-s ./standard_catalogue_071014/SS06 \
-s ./standard_catalogue_071014/SS07 \
-s ./standard_catalogue_071014/SS08 \
-s ./standard_catalogue_071014/SS09 \
-s ./standard_catalogue_071014/SS10 \
-s ./standard_catalogue_071014/SS15 \
-s ./standard_catalogue_071014/SS16 \
-s ./standard_catalogue_071014/SS17 \
-s ./standard_catalogue_071014/SS18 \
-s ./standard_catalogue_071014/SS19 \
-s ./standard_catalogue_071014/SS20 \
-s ./standard_catalogue_071014/SS21 \
-s ./standard_catalogue_071014/SS22 \
-s ./standard_catalogue_071014/SS24 \
-s ./standard_catalogue_071014/SS25 \
-s ./standard_catalogue_071014/SS26 \
-s ./standard_catalogue_071014/SS27 \
-s ./standard_catalogue_071014/SS28 \
-s ./standard_catalogue_071014/SS29 \
-s ./standard_catalogue_071014/SS32 \
-s ./standard_catalogue_071014/SS33 \
-s ./standard_catalogue_071014/SS34

### STEP 3: SSTACKS ###

echo "|| STANDARD SSTACKS ||"

# first generate a list of file names 

list=$(for i in ./standard_catalogue_071014/[^b]*.tsv.gz; do echo ${i%.*.*.*}; done | uniq)

# then run the sstacks command on them

for file in $list;
do
	echo $file
	sstacks -b 1 -c ./standard_catalogue_071014/batch_1 -s $file -p 12 \
	-o ./standard_catalogue_071014/
done

### STEP 4: POPULATIONS ###

echo "|| STANDARD POPULATIONS ||"

# set populations variables here
FREQ_CUT=0.5
POP_PRES=2
MIN_DEPTH=30
MAF=0.08

#salto
populations -P ./standard_catalogue_071014/ -M ./popmaps/popmap_salto_071014 -b 1 -t 12 \
-r $FREQ_CUT -p $POP_PRES -m $MIN_DEPTH -a $MAF -f p_value --genepop --vcf

mkdir ./standard_catalogue_071014/salto_071014/
mv ./standard_catalogue_071014/batch_1.[^c]* ./standard_catalogue_071014/salto_071014/

#ramso
populations -P ./standard_catalogue_071014/ -M ./popmaps/popmap_ramso_071014 -b 1 -t 12 \
-r $FREQ_CUT -p $POP_PRES -m MIN_DEPTH -a $MAF -f p_value --genepop --vcf

mkdir ./standard_catalogue_071014/ramso_071014/
mv ./standard_catalogue_071014/batch_1.[^c]* ./standard_catalogue_071014/ramso_071014/

#jut
populations -P ./standard_catalogue_071014/ -M ./popmaps/popmap_jut_071014 -b 1 -t 12 \
-r $FREQ_CUT -p $POP_PRES -m MIN_DEPTH -a $MAF -f p_value --genepop --vcf

mkdir ./standard_catalogue_071014/jut_071014/
mv ./standard_catalogue_071014/batch_1.[^c]* ./standard_catalogue_071014/jut_071014/

# all
populations -P ./standard_catalogue_071014/ -M ./popmaps/popmap_all_071014 -b 1 -t 12 \
-r $FREQ_CUT -p 6 -m $MIN_DEPTH -a $MAF -f p_value --genepop --vcf

mkdir ./standard_catalogue_071014/all_071014/
mv ./standard_catalogue_071014/batch_1.[^c]* ./standard_catalogue_071014/all_071014/